<?php
/**
 * Plugin Name: wpotp
 * Plugin URI: http://www.totp.me/
 * Description: Totp.Me
 * Version: 0
 * Author: Totp.Me
 * Author URI: http://www.totp.me/
 * License: copyright totp.me . all rights reserved. redistribution forbidden.
 */

/* developed on wordpress 3.9.2 */

require_once("lib/otpc.php");
require_once("key.php");

add_action('wp_authenticate_user' , 'totp_login', 10, 2);
function totp_login($user, $password) {
  if (is_wp_error($user)) return $user;
  $username = $user->user_login;
  session_start();
  if ($username == $_SESSION["authed"]) return $user;
  $_SESSION["tentative"] = $username;
  $_SESSION["tentative_password"] = $password;
  if (!empty($_POST["rememberme"]))
    $_SESSION["rememberme2"] = $_POST["rememberme"];
  redirect(auth($_SESSION, $username));
}

add_action("wp_logout", "totp_logout");
function totp_logout() {
  session_start();
  unset($_SESSION["authed"]);
}

add_action("show_user_profile", "totp_prov");
function totp_prov($u) {
  echo "<a href=\"".plugins_url("changetotp.php",__FILE__)."\">".
       "two-factor authentication</a>";
}

//consider: redirect to deep link on login
//does session timeout? if not, then you're remembering TOTP auth indefinitely
//  if user doesn't logout
?>
